<!--
 * @FilePath: \gitscreenFront\src\views\electronicControlAmbient\chart\verticalNum.vue
 * @Author: 王路平
 * @文件版本: V1.0.0
 * @Date: 2023-02-13 08:22:35
 * @Description: 
 * 
 * 版权信息         : 2023 by ${再登软件}, All Rights Reserved.
-->
<template>
  <div ref="numBox1" :style="{ height: boxSize.height, width: boxSize.width }">
    <border6 ref="refborder3">
      <template v-slot>
        <div class="box" ref="classBox1">
          <h2>{{ props.title }}</h2>
          <h5 v-if="value.unit">{{
            `${t('messages.NormalValue')}0-${value.quota}${value.unit}` }}</h5>
          <!-- <h2>{{ `${t(item.i18n[0])}${t(item.i18n[1])}`}}</h2> -->
          <i :class="['iconfont',value.iconname,iconColor,'iconbig-size']"></i>
          <p class="unit" v-if="value.unit&&item.status">
          <p class="num">{{ item.val }}</p>
          <span>{{ value.unit }}</span>
          </p>

        </div>
      </template>
    </border6>
  </div>
</template>

<script setup lang="ts">
import { onMounted, reactive, ref, watch, computed, onUnmounted } from "vue";
import border6 from "@/components/borderBox/border6.vue";
import { verticalNumPerson } from "@/type/realtimeSecurity";
import { warningNot } from "@/utils/notification";

import { useI18n } from 'vue-i18n'
let { t } = useI18n();
let props = defineProps<{
  title: string;
}>();
let i = ref(0)
let item = computed(() => {
  return value.data[i.value] || { "name": "", "val": "0", "type": "", "field": "", "ts": 0,status:false };
});

let iconColor = computed(() => {
  return value.data[i.value]?.status?(value.data[i.value].val > value.quota ? "icon-red" : "icon-blue"):"icon-grey";
});
let keynum = ref(0);
const value = reactive<any>({
  data: [],
  unit: "",
  quota: null,
  iconname: "",
});

let refborder3 = ref();
let numBox1 = ref();
const classBox1 = ref()
let timer: any = null;
onMounted(() => {

});
onUnmounted(() => {
  clearInterval(timer);
})

const boxSize = reactive({
  height: '',
  width: ''
})

function setchartWH(width: any, height: any) {
  boxSize.height = height + 'px'
  boxSize.width = width + 'px'
  refborder3.value.resetWH();
}

const setData = (
  data?: number | null,
  iconname?: string,
  quota?: number | null,
  unit?: string
) => {
  value.data = data;
  value.iconname = iconname;
  value.quota = quota;
  value.unit = unit;
  keynum.value++;

  clearInterval(timer);
  timer = setInterval(() => {
    i.value++;
    if (i.value >= value.data.length) {
      i.value = 0;
    }
  }, 5000);
};

defineExpose({
  setchartWH,
  setData,
});
</script>

<style scoped>
@import "@/assets/css/iconfont.css";

.box {
  height: 50%;
  width: 100%;
  box-sizing: border-box;
  display: flex;
  flex-direction: column;
  justify-content: space-evenly;
  align-items: center;
}

.box>h5 {
  font-size: 15px;
  /* margin-bottom: 20px; */
  margin-top: 20px;
}

/* .contentbox{
  height: 100%;
  width: 100%;
  display: flex;
  flex-direction: column;
  justify-content: space-around;
  align-items: center;
} */
h2 {
  color: #fff;
}

p {
  color: #fff;
}

.iconbig-size {  
  font-size: 100px;
}

.icon-red {
  color: #E43961;
  animation: redstart 2s infinite;
  /* position: relative; */
  /* top: -15px; */
}

.icon-blue {
  color: #20AEC5;
  /* position: relative; */
  /* top: -15px; */
}
.icon-grey {
  color: rgb(167, 166, 189);
  /* position: relative; */
  /* top: -15px; */
}

.iconsmall-size {
  font-size: 20px;
}

.num {
  font-size: 16px;
}

.unit {
  display: flex;
  justify-content: center;
  align-items: center;
  vertical-align: top;
  font-size: 16px;
  height: 5;
  width: 100px;
}

.box>h2 {
  font-size: 20px;
  position: absolute;
top: 15px;
left:20px;
}


.icontip {
  display: flex;
  margin-top: -60px;
  width: 100px;
  flex-wrap: wrap;
  align-items: center;
  justify-content: center;
  height: 60px;
}

.icontipBox li {
  display: flex;
  align-items: center;
  justify-content: flex-start;
  margin-bottom: 5px;
}

.icontipBox li p:nth-child(1) {
  width: 40%;
  text-align: left;
}

.icontipBox li p:nth-child(2) {
  flex: 1;
}

@keyframes redstart {
  0% {}

  50% {
    text-shadow: #fff 1px 0 10px;
  }

  100% {}
}</style>
